require "defines"
-----------------------------------------------------------------------------------------------------------------------
script.on_init(function()
	set_handlers()
end)
 
script.on_load(function()
	set_handlers()
end)
 
function set_handlers()
	script.on_event(defines.events.on_built_entity, build_entity_handler)
	script.on_event(defines.events.on_robot_built_entity, build_entity_handler)
	script.on_event(defines.events.on_preplayer_mined_item, break_entity_handler)
	script.on_event(defines.events.on_robot_pre_mined, break_entity_handler)
	script.on_event(defines.events.on_entity_died, break_entity_handler)
	script.on_event(defines.events.on_player_mined_item, break_entity_handler)
	script.on_event(defines.events.on_robot_mined, break_entity_handler)
	script.on_event(defines.events.on_tick, process_tick)
end

-----------------------------------------------------------------------------------------------------------------------
----------------------------------------------------Methoden-----------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function get_lgt (e, recover)
	for i, lgt in pairs(global.lgts) do
		if e == lgt.chest then
			return lgt, i
		end
	end
	return nil, nil
end
-----------------------------------------------------------------------------------------------------------------------
----------------------------------------------------Variablen----------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
is_logisticTurret = {}
is_logisticTurret["logistic-gun-turret"] = 1

-----------------------------------------------------------------------------------------------------------------------
-------------------------------------------------Build-Event-----------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function build_entity_handler(event)
	local e = event.created_entity
	local ctype = e.name
	if e == nil or not is_logisticTurret[ctype] then return end
	local player = event.player_index and game.players[event.player_index]
	local s = e.surface
	local p = e.position
	local f = e.force
	local t = s.create_entity{name = "gun-turret", position = p, force = f}
	e.destroy()
	local c = s.create_entity{name = ctype, position = p, force = f}
	c.set_request_slot ({name="piercing-bullet-magazine", count=25}, 1)
	t.operable=false
	t.minable = false
	t.destructible = false
	local lgt = {turret=t, chest=c}
	if global.lgts == nil then global.lgts = {} end
	table.insert(global.lgts, lgt)
end

-----------------------------------------------------------------------------------------------------------------------
-------------------------------------------------Break-Event-----------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function break_entity_handler(event)
	local e = event.entity	
	if e == nil or not is_logisticTurret[e.name] then return end
	local lgt,i = get_lgt(e,true)
	if lgt == nil then return end
	table.remove(global.lgts, i)
	if not lgt.turret.get_inventory(1).is_empty() then
		lgt.chest.insert(lgt.turret.get_inventory(1)[1])
	end
	lgt.turret.destroy()
end

-----------------------------------------------------------------------------------------------------------------------
-------------------------------------------------Tick-Event------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function process_tick(event)
	if global.lgts == nil then return end
	for i, lgt in pairs(global.lgts) do
		if lgt.chest == nil then return end
		local turret_inv = lgt.turret.get_inventory(1)
    	if turret_inv.is_empty() then
        	local chest_inv = lgt.chest.get_inventory(1)
        	if not chest_inv.is_empty() then
            	local item = chest_inv[1]
            	if item.prototype.type == "ammo" and item.count > 0 and lgt.turret.can_insert(item) then
                	lgt.turret.insert({name = item.prototype.name, count = 1})
                	item.count = item.count - 1
            	end
        	end
        end
    end
end